/*
 * Copyright (c) "Neo4j"
 * Neo4j Sweden AB [https://neo4j.com]
 *
 * This file is part of Neo4j.
 *
 * Neo4j is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */
package org.neo4j.csv.reader;

public class DataAfterQuoteException extends FormatException {
    public DataAfterQuoteException(SourceTraceability source, String readValue) {
        super(
                source,
                " there's a field starting with a quote and whereas it ends that quote there seems"
                        + " to be characters in that field after that ending quote. That isn't supported."
                        + " This is what I read: '"
                        + readValue + "'");
    }
}
